import * as d3 from 'd3';
import { NiruChart } from './niruchart';
import { Mouldtype, Mouldconfigs, MappingChartdata } from './niruchart_models';

export class Sidemenu {
  
  chartobj: NiruChart;
  sidemenuwidth: number;
  sidemenuHeight: number;
  parentsvgid: string;
  menuareagid: any;
  menuleafg: any = null;
  

/*
  constructor(width,height,parentsvgid) {
    this.sidemenuwidth = width;
    this.sidemenuHeight = height;
    this.parentsvgid = parentsvgid;
   }
   */

   constructor(chartobj:NiruChart) {
     console.log("$$$$$");
     console.log(chartobj);
      this.chartobj = chartobj;
      this.sidemenuwidth = this.chartobj.sidemenuwidth;      
      //this.sidemenuHeight = this.chartobj.chartHeight;
      this.sidemenuHeight = 100;
      this.parentsvgid = this.chartobj.chartsvgid;

      // This is only for testing
          let mould1 : Mouldconfigs = {
        "mouldType": { 
                        "mouldGroup": "io",
                        "moduleId": "pandas",
                        "submoduleId": "read",
                        "mouldId": "io_csv"
                      },
        "dispname": "pandas.read_csv",
        "mould_class":"rect_in_out_port_leaf",
        "color_config" : { "port" : {
                          "fill": "#FFE4C4",
                          "stroke": "#DAA520",
                          "stroke_width": 2
                          },
                          "drag_port" : {
                          "fill": "#FFE4C4",
                          "stroke": "#DAA520",
                          "stroke_width": 2
                          },
                          "body" : {
                          "fill": "#FFE4C4",
                          "stroke": "#DAA520",
                          "stroke_width": 2
                          }
                        },
        "mould_form": {}
       };
     // this.create_side_menu(mould1);
   }

  create_side_menu(mould: Mouldconfigs) {
    //this.chartobj.chartsidemenu = this;
    this.drawmenupanel();

    this.drawmenuleafs(mould);
  }

  drawmenupanel() {
    console.log("draepanel",this.parentsvgid);
    console.log(this.chartobj);
    this.menuareagid = d3.select("#"+ this.parentsvgid)
                            .append("g")
                            .attr("id",this.chartobj.sidemenugelement);

    this.menuareagid.append("rect")
          .attr("id","lmenu")
          .attr("width", this.sidemenuwidth)
          .attr("height",  this.sidemenuHeight*1.3)
          .attr("x", 0)
          .attr("y", -20)
          .attr("fill",  "green")
          .attr("stroke-width",2)
          .attr("stroke","black");                          
  }

  drawmenuleafs(mould: Mouldconfigs) {

    let ds: MappingChartdata = <MappingChartdata>{};
    ds.id =  new Date().getTime().toString();
    ds.x = 40;
    ds.y = 70;
    ds.leaf_d_txt = [];
    ds.leaf_d_txt.push([]);
    ds.leaf_d_txt[0].push(mould.dispname);
    ds.mould_conf = JSON.parse(JSON.stringify(mould));
    ds.parentIds= [];
    ds.nodedata={};
    
    let ddsd = this.chartobj.getInstance("custom_"+ /*"rect_in_out_port_leaf"*/ds.mould_conf.mould_class,
    ds.x,ds.y,null,"g#leaf_"+ds.id, ds.leaf_d_txt,this.chartobj,ds.nodedata);
   

    /*
    console.log("leaf");
    if(this.menuleafg === null) {
        this.menuleafg = d3.select("#"+ this.parentsvgid)
                            .append("g")
                            .attr("id","sidemenuleafs");
    }

    let menuitem = this.menuleafg.append("rect")
          .attr("id","dontm")
          .attr("width", "150")
          .attr("height", "40")
          .attr("x", 40)
          .attr("y", 70)
          .attr("fill",  "#FFE4C4");

          menuitem.call(d3.drag()
                          //.on("start", ((d,i, n) =>this.node_dragstarted(d, i, n)))
                          .on("drag", ((d,i, n) =>this.move(d, i, n))));
  */
  }

  private move(d:any,i:number,n:any) {
      d3.select(n[i])
      .attr('x', d3.event.x )
      .attr('y', d3.event.y );

  };

}